/*
Copyright (c) 2019-2022 Digital Energy Cloud Solutions LLC. All Rights Reserved.
Authors:
Petr Krutov, <petr.krutov@digitalenergy.online>
Stanislav Solovev, <spsolovev@digitalenergy.online>
Kasim Baybikov, <kmbaybikov@basistech.ru>

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
Terraform DECORT provider - manage resources provided by DECORT (Digital Energy Cloud
Orchestration Technology) with Terraform by Hashicorp.

Source code: https://repository.basistech.ru/BASIS/terraform-provider-decort

Please see README.md to learn where to place source code so that it
builds seamlessly.

Documentation: https://repository.basistech.ru/BASIS/terraform-provider-decort/wiki
*/

package zone

import (
	"context"
	"strconv"

	"repository.basistech.ru/BASIS/decort-golang-sdk/pkg/cloudbroker/zone"
	"repository.basistech.ru/BASIS/terraform-provider-decort/internal/controller"

	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/schema"
	log "github.com/sirupsen/logrus"
)

func utilityZoneCheckPresence(ctx context.Context, d *schema.ResourceData, m interface{}) (*zone.RecordZone, error) {
	c := m.(*controller.ControllerCfg)
	req := zone.GetRequest{}

	if d.Id() != "" {
		zoneId, _ := strconv.ParseUint(d.Id(), 10, 64)
		req.ID = zoneId
	} else {
		req.ID = uint64(d.Get("zone_id").(int))
	}

	zoneData, err := c.CloudBroker().Zone().Get(ctx, req)
	if err != nil {
		return nil, err
	}

	return zoneData, nil
}

func utilityZoneUpdate(ctx context.Context, d *schema.ResourceData, m interface{}, zoneID uint64) error {
	c := m.(*controller.ControllerCfg)

	if d.HasChanges("name", "description", "auto_start") {
		req := zone.UpdateRequest{
			ID: zoneID,
		}

		if d.HasChange("name") {
			req.Name = d.Get("name").(string)
		}
		if d.HasChange("description") {
			req.Description = d.Get("description").(string)
		}

		if d.HasChange("auto_start") {
			req.AutoStart = d.Get("auto_start").(bool)
		}

		_, err := c.CloudBroker().Zone().Update(ctx, req)
		if err != nil {
			return err
		}
		log.Debugf("utilityZoneUpdate: update zone with ID: %d, complete with params=%v", zoneID, req)
	}

	addedNodes := make([]interface{}, 0)
	removedNodes := make([]interface{}, 0)

	old_set, new_set := d.GetChange("node_ids")
	oldSlice := old_set.([]interface{})
	newSlice := new_set.([]interface{})

	for _, oldElem := range oldSlice {
		if !containsNodes(newSlice, oldElem) {
			removedNodes = append(removedNodes, oldElem)
		}
	}

	for _, newElem := range newSlice {
		if !containsNodes(oldSlice, newElem) {
			addedNodes = append(addedNodes, newElem)
		}
	}

	log.Debugf("Found node_ids change with %v deletion(s) and %v addition(s) [zoneID=%v]", len(removedNodes), len(addedNodes), zoneID)

	if len(addedNodes) > 0 {

		addedUint := make([]uint64, len(addedNodes))
		for i, v := range addedNodes {
			addedUint[i] = uint64(v.(int))
		}

		req := zone.AddNodeRequest{
			ID:      zoneID,
			NodeIDs: addedUint,
		}
		if _, err := c.CloudBroker().Zone().AddNode(ctx, req); err != nil {
			return err
		}

	}

	if len(removedNodes) > 0 {
		removedUint := make([]uint64, len(removedNodes))
		for i, v := range removedNodes {
			removedUint[i] = uint64(v.(int))
		}

		req := zone.DelNodeRequest{
			ID:      zoneID,
			NodeIDs: removedUint,
		}
		log.Debug("del")
		log.Debug(req.NodeIDs)
		if _, err := c.CloudBroker().Zone().DelNode(ctx, req); err != nil {
			return err
		}
	}

	return nil
}

func containsNodes(set []interface{}, check interface{}) bool {
	for _, elem := range set {
		elemConv := elem.(int)
		checkConv := check.(int)
		if elemConv == checkConv {
			return true
		}
	}

	return false
}
